<template>
  <div class="relative mt-10">
    <div class="w-full flex flex-wrap gap-3 mb-2 items-center">
      <h1
        class="text-xl font-bold tracking-tight text-gray-900 dark:text-white"
      >
        <slot name="title" />
      </h1>
      <button
        v-if="suggestGeoloc && userLocation.isIPLocation"
        class="inline-flex bg-primary rounded text-white flex-initial px-4 py-2 justify-center w-full md:w-min whitespace-nowrap"
        @click="$emit('doGeoLoc')"
      >
        {{ $gettext('Geolocate me') }}
      </button>
    </div>
    <div class="hidden sm:block" v-show="showScrollLeftButton">
      <button
        @click="scrollLeft"
        class="absolute inset-y-0 my-auto z-10 rounded-full bg-white w-10 h-10 border border-shadowColor -left-5"
      >
        <div class="">&lt;</div>
      </button>
    </div>
    <div class="overflow-hidden">
      <div
        class="relative w-full flex gap-6 snap-x overflow-x-auto pb-6"
        ref="scrollContainer"
        @scroll="scrollHandler"
      >
        <slot name="content" />
      </div>
    </div>
    <div class="hidden sm:block" v-show="showScrollRightButton">
      <button
        @click="scrollRight"
        class="absolute inset-y-0 my-auto z-10 rounded-full bg-white w-10 h-10 border border-shadowColor -right-5"
      >
        <div class="">&gt;</div>
      </button>
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { useGettext } from 'vue3-gettext'
  import { inject, onMounted, onUnmounted, ref } from 'vue'
  import { LocationType } from '../../../../shared/user-location.model'

  withDefaults(defineProps<{ suggestGeoloc?: boolean }>(), {
    suggestGeoloc: true,
  })

  const { $gettext } = useGettext()

  const { userLocation } = inject<{
    userLocation: LocationType
  }>('userLocation')
  const showScrollRightButton = ref(true)
  const showScrollLeftButton = ref(false)

  const scrollContainer = ref<Element | null>(null)

  const scrollHandler = () => {
    showScrollRightButton.value =
      scrollContainer.value.scrollLeft <
      scrollContainer.value.scrollWidth - scrollContainer.value.clientWidth
    showScrollLeftButton.value = scrollContainer.value.scrollLeft > 0
  }

  const doScroll = (e: Event, left: number) => {
    e.preventDefault()
    scrollContainer.value.scrollBy({
      left,
      behavior: 'smooth',
    })
  }

  const scrollLeft = (e: Event) => {
    doScroll(e, -300)
  }

  const scrollRight = (e: Event) => {
    doScroll(e, 300)
  }

  const scrollHorizontalToVertical = (evt: WheelEvent) => {
    evt.deltaY > 0 ? doScroll(evt, 600) : doScroll(evt, -600)
  }

  onMounted(async () => {
    scrollContainer.value.addEventListener('wheel', scrollHorizontalToVertical)
  })

  onUnmounted(() => {
    if (scrollContainer.value) {
      scrollContainer.value.removeEventListener(
        'wheel',
        scrollHorizontalToVertical
      )
    }
  })
</script>
